$(document).ready(function () {
    $("body").on("blur", " .itemname, .srno", itemModalShow);
    $(".iTbody").on("click", ".itemTr", addTrVal);
    $(".itemModal").on("keyup", ".isearch", getItemData);
    $(".itemModal").on("change", ".isortBy, iorderAS", getItemData);
    $(".inoRecord").hide();

    window.addEventListener('keydown', function (e) {
        if (e.keyIdentifier == 'U+000A' || e.keyIdentifier == 'Enter' || e.keyCode == 13) {
            if (e.target.nodeName == 'INPUT' && e.target.type == 'text' && e.target.className == "iname") {
                addTrVal(e);
            }
        }
    }, true);
    
    

    function itemModalShow() {
        var tr = $(this).closest("tr"),
                file = $(".file").val(),
                srno = tr.find(".srno").val(),
                margin = srno * 2.5,
                itemname = tr.find(".itemname").val();
        var type = $('.type').val();
        $(".modal-content").css("margin-top", margin + "%")

        if (itemname == "") {
            $(".itemname").removeClass("dataItemname");
            $(".hsncode").removeClass("dataHsncode");
            $(".gstperc").removeClass("dataGstperc");
            $(".rate").removeClass("dataRate");
            $(".unit").removeClass("dataUnit");

            tr.find(".itemname").addClass("dataItemname");
            tr.find(".hsncode").addClass("dataHsncode");
            tr.find(".gstperc").addClass("dataGstperc");
            tr.find(".rate").addClass("dataRate");
            tr.find(".unit").addClass("dataUnit");

            $(".itemModal").modal("show");
            getItemData();
        } else {
            
                  $.ajax({
                type: "POST",
                datatype: "json",
                url: "search_rbarcode.php",
                data: {itemname: itemname, file:file, type: type},
                success: function (response) {
                    var m = response;

                    tr.find(".itemname").val(m.name);
                    tr.find(".hsncode").val(m.hsncode);
                    tr.find(".unit").val(m.unit);
                    tr.find(".gstperc").val(m.gstperc);
//                    debugger
                    var rate = tr.find(".rate").val();
                    if (rate != 0) {
                        tr.find(".rate").val(rate);
                    } else {
                        tr.find(".rate").val(m.rate);
                    }

                    tr.find(".qty").focus();

                },
                error: function (request, textStatus, errorThrown) {

                }
            });
        }
    }

    $(".itemModal").on('shown.bs.modal', function () {
        $(".isearch").focus();
        $(".isearch").val("");
        $(".ifield").val("1");
        getItemData();
    });

    $(".itemModal").on('hidden.bs.modal', function () {
        $(".dataQty").focus();
        $(".dataQty").select();
    });

    var imrangeFrom = 0,
            imrangeTo = 40;

    function getItemData(pagination) {

        $(".iloader").show();

        if (pagination == 'prev') {
            if (imrangeFrom > 0) {
                imrangeFrom = (imrangeFrom - 40);
                imrangeTo = (imrangeTo - 40);
            }
        }
        if (pagination == 'next') {
            imrangeFrom = (imrangeFrom + 40);
            imrangeTo = (imrangeTo + 40);
        }

        var vouchno = $(".vouchno").val(),
                file = $(".file").val(),
                isearch = $(".isearch").val(),
                ifield = $(".ifield").val(),
                ioperator = $(".ioperator").val(),
                sortBy = $(".isortBy").val(),
                orderAs = $(".iorderBy").val(),
                 type = $('.type').val(),
                data = {isearch: isearch, ifield: ifield, ioperator: ioperator, sortBy: sortBy, orderAs: orderAs,
                    vouchno: vouchno, file: file, rangeFrom: imrangeFrom, rangeTo: imrangeTo, type: type},
        values = "";
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "search_raw.php",
            data: data,
            success: function (response) {
                $.each(response, function () {
                    values += "<tr class='itemTr'>" +
                            "<td align='left'><input type='text' class='iname' value='" + this.name + "' readonly style='width:100%'></td>" +
                            "<td align='left'><input type='text' class='ihsncode' value='" + this.hsncode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='igstperc' value='" + this.gstperc + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='iunit' value='" + this.unit + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='irate' value='" + this.rate + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "</tr>";
                });
                $(".iloader").hide();
                $(".iTbody").empty();
                $(".iTbody").html(values);
                if (response) {
                    $(".search-action-bar").show();
                }
            },
            error: function (request, textStatus, errorThrown) {

            }
        });
    }
    $(".iload").click(function () {
        getItemData();
    });
//    $(".isearch").change(function () {
//        getItemData();
//    });
    $(".iprevious").click(function () {
        getItemData('prev');
    });
    $(".inext").click(function () {
        getItemData('next');
    });

    function addTrVal(e) {
        var tr = "";
        if (e == "undefined") {
            tr = $(this).closest("tr");
        } else {
            tr = $(e.target).closest("tr");
        }

        var iname = tr.find(".iname").val(),
                iunit = tr.find(".iunit").val(),
                ihsncode = tr.find(".ihsncode").val(),
                igstperc = tr.find(".igstperc").val(),
                irate = tr.find(".irate").val();
                
                

        $(".dataItemname").val(iname);
        $(".dataUnit").val(iunit);
        $(".dataHsncode").val(ihsncode);
        $(".dataGstperc").val(igstperc);
        $(".dataRate").val(irate);


        $(".dataItemname").removeClass('dataItemname');
        $(".dataUnit").removeClass("dataUnit");
        $(".dataHsncode").removeClass("dataHsncode");
        $(".dataGstperc").removeClass("dataGstperc");
        $(".dataRate").removeClass("dataRate");

        $(".itemModal").modal("hide");
        $(".qty").focus();
        

    }


    $(".rate").blur(function () {
        $(".dataRate").removeClass("dataRate");
    });
});